package MT::Plugin::Normalize;
use strict;

require MT::Plugin;

@MT::Plugin::Normalize::ISA = qw(MT::Plugin);

our $version = "0.1";

my $plugin = new MT::Plugin::Normalize({
	name => 'Normalize',
	version => $version,
	description => 'use Unicode::Normalize;',
	author_name => 'Junnama Noda',
	author_link => 'http://junnama.alfasado.net/online/',
});

MT->add_plugin($plugin);

MT::Template::Context->add_global_filter(normalize => \&_normalize);

sub _normalize {
	my($text, $arg, $ctx) = @_;
	use utf8;
	use Encode;
	$text = decode('utf-8', $text);
	$text =~ s/＜/&lt;/g;
	$text =~ s/＞/&gt;/g;
	$text =~ s/＆/&amp;/g;
	$text =~ s/[“|”]/&quot;/g;
	use Unicode::Normalize;
	if ($arg eq 'NFD') {
		$text = NFD($text);
	} elsif ($arg eq 'NFC') {
		$text = NFC($text);
	} elsif ($arg eq 'NFKD') {
		$text = NFKD($text);
	} else {
		$text = NFKC($text);
	}
	$text = encode('utf-8', $text);
	return $text;
}

1;